<?xml version="1.0" encoding="UTF-8"?>
<!--
Copyright (C) 2014-2018  Stephan Kreutzer

This file is part of html2latex1.

html2latex1 is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License version 3 or any later version,
as published by the Free Software Foundation.

html2latex1 is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU Affero General Public License 3 for more details.

You should have received a copy of the GNU Affero General Public License 3
along with html2latex1. If not, see <http://www.gnu.org/licenses/>.
-->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xhtml="http://www.w3.org/1999/xhtml" xmlns="http://www.w3.org/1999/xhtml" exclude-result-prefixes="xhtml">
  <xsl:output method="text" encoding="UTF-8"/>

  <xsl:template match="xhtml:html">
    <xsl:text>\documentclass[a4paper]{memoir}&#xA;</xsl:text>
    <xsl:text>% This file was generated by layout1 for html2latex1, which is free software licensed under the GNU Affero General Public License 3 or any later version (see https://gitlab.com/publishing-systems/automated_digital_publishing/ and http://www.publishing-systems.org).&#xA;</xsl:text>
    <xsl:text>&#xA;</xsl:text>
    <xsl:text>\usepackage[utf8]{inputenc}&#xA;</xsl:text>
    <xsl:text>\usepackage[T1]{fontenc}&#xA;</xsl:text>
    <xsl:text>\usepackage{lmodern}&#xA;</xsl:text>
    <xsl:text>\usepackage{ngerman}&#xA;</xsl:text>
    <xsl:text>\usepackage[hidelinks]{hyperref}&#xA;</xsl:text>
    <xsl:text>&#xA;</xsl:text>
    <xsl:text>\setlength{\parskip}{0pt}&#xA;</xsl:text>
    <xsl:text>&#xA;</xsl:text>
    <!-- No support for attaching a visual display to semantically encoded lists yet. -->
    <xsl:text>\renewcommand{\theenumi}{\arabic{enumi}}&#xA;</xsl:text>
    <xsl:text>\renewcommand{\labelenumi}{\theenumi}&#xA;</xsl:text>
    <xsl:text>\renewcommand{\theenumii}{\arabic{enumii}}&#xA;</xsl:text>
    <xsl:text>\renewcommand{\labelenumii}{\theenumii}&#xA;</xsl:text>
    <xsl:text>\renewcommand{\theenumiii}{\arabic{enumiii}}&#xA;</xsl:text>
    <xsl:text>\renewcommand{\labelenumiii}{\theenumiii}&#xA;</xsl:text>
    <xsl:text>\renewcommand{\theenumiv}{\arabic{enumiv}}&#xA;</xsl:text>
    <xsl:text>\renewcommand{\labelenumiv}{\theenumiv}&#xA;</xsl:text>
    <xsl:text>
\renewcommand*{\maketitle}{%
  \thispagestyle{empty}
  \begingroup%
    \vspace*{\baselineskip}
    \vfill
    \hbox{%
      \vbox{%
        \vspace{0.1\textheight}
        {\noindent\HUGE\bfseries\centering </xsl:text>
        <xsl:value-of select="xhtml:head/xhtml:title//text()"/>
        <xsl:text>\par}\vspace*{5\baselineskip}&#xA;</xsl:text>
        <xsl:if test="xhtml:head/xhtml:meta[@name='author']">
          <xsl:text>        {\Large\centering </xsl:text>
          <xsl:value-of select="xhtml:head/xhtml:meta[@name='author']/@content"/>
          <xsl:text>\par}&#xA;</xsl:text>
        </xsl:if>
        <xsl:text>        \vspace{0.35\textheight}</xsl:text>
        <xsl:if test="xhtml:head/xhtml:meta[@name='publisher']">
          <xsl:text>&#xA;        {\noindent\centering </xsl:text>
          <xsl:value-of select="xhtml:head/xhtml:meta[@name='publisher']/@content"/>
          <xsl:text>\par}</xsl:text>
        </xsl:if>
        <xsl:text> 
      }%
    }%
    \vfill
    \null
  \endgroup%
  \pagebreak{}
  \newpage{}
  \thispagestyle{empty}
  \mbox{}
  \pagebreak{}
}
    </xsl:text>
    <xsl:text>&#xA;</xsl:text>
    <xsl:text>\begin{document}&#xA;</xsl:text>
    <xsl:text>\frontmatter&#xA;</xsl:text>
    <xsl:text>\maketitle&#xA;</xsl:text>
    <xsl:text>\tableofcontents&#xA;</xsl:text>
    <xsl:text>\mainmatter&#xA;</xsl:text>
    <xsl:apply-templates select="xhtml:body"/>
    <xsl:text>\end{document}&#xA;</xsl:text>
  </xsl:template>

  <xsl:template match="xhtml:html/xhtml:body/xhtml:div">
    <xsl:choose>
      <xsl:when test="xhtml:h1">
        <xsl:text>\part{</xsl:text>
        <xsl:value-of select="xhtml:h1"/>
        <xsl:text>}&#xA;</xsl:text>
      </xsl:when>
      <xsl:when test="xhtml:h2">
        <xsl:text>\chapter{</xsl:text>
        <xsl:value-of select="xhtml:h2"/>
        <xsl:text>}&#xA;</xsl:text>
      </xsl:when>
    </xsl:choose>
    <xsl:apply-templates/>
  </xsl:template>
  <xsl:template match="xhtml:html/xhtml:body/xhtml:div/xhtml:p[@class='paragraph_default']">
    <!--apply-templates/-->
    <xsl:for-each select="*|text()">
      <xsl:apply-templates select="."/>
    </xsl:for-each>
    <xsl:text>&#xA;&#xA;</xsl:text>
  </xsl:template>
  <xsl:template match="xhtml:html/xhtml:body/xhtml:div/xhtml:p[@class='paragraph_default']//text()">
    <xsl:value-of select="."/>
  </xsl:template>

  <xsl:template match="xhtml:html/xhtml:body/xhtml:div/xhtml:div">
    <xsl:choose>
      <xsl:when test="xhtml:h2">
        <xsl:text>\chapter{</xsl:text>
        <xsl:value-of select="xhtml:h2"/>
        <xsl:text>}&#xA;</xsl:text>
      </xsl:when>
      <xsl:when test="xhtml:h3">
        <xsl:text>\section{</xsl:text>
        <xsl:value-of select="xhtml:h3"/>
        <xsl:text>}&#xA;</xsl:text>
      </xsl:when>
    </xsl:choose>
    <xsl:apply-templates/>
  </xsl:template>
  <xsl:template match="xhtml:html/xhtml:body/xhtml:div/xhtml:div/xhtml:p[@class='paragraph_default']">
    <xsl:apply-templates/>
    <xsl:text>&#xA;&#xA;</xsl:text>
  </xsl:template>
  <xsl:template match="xhtml:html/xhtml:body/xhtml:div/xhtml:div/xhtml:p[@class='paragraph_default']//text()">
    <xsl:value-of select="."/>
  </xsl:template>

  <xsl:template match="xhtml:html/xhtml:body/xhtml:div/xhtml:div/xhtml:div">
    <xsl:choose>
      <xsl:when test="xhtml:h3">
        <xsl:text>\section{</xsl:text>
        <xsl:value-of select="xhtml:h3"/>
        <xsl:text>}&#xA;</xsl:text>
      </xsl:when>
      <xsl:when test="xhtml:h4">
        <xsl:text>\subsection{</xsl:text>
        <xsl:value-of select="xhtml:h4"/>
        <xsl:text>}&#xA;</xsl:text>
      </xsl:when>
    </xsl:choose>
    <xsl:apply-templates/>
  </xsl:template>
  <xsl:template match="xhtml:html/xhtml:body/xhtml:div/xhtml:div/xhtml:div/xhtml:p[@class='paragraph_default']">
    <xsl:apply-templates/>
    <xsl:text>&#xA;&#xA;</xsl:text>
  </xsl:template>
  <xsl:template match="xhtml:html/xhtml:body/xhtml:div/xhtml:div/xhtml:div/xhtml:p[@class='paragraph_default']//text()">
    <xsl:value-of select="."/>
  </xsl:template>

  <xsl:template match="xhtml:html/xhtml:body/xhtml:div/xhtml:div/xhtml:div/xhtml:div">
    <xsl:if test="xhtml:h4">
      <xsl:text>\subsection{</xsl:text>
      <xsl:value-of select="xhtml:h4"/>
      <xsl:text>}&#xA;</xsl:text>
    </xsl:if>
    <xsl:apply-templates/>
  </xsl:template>
  <xsl:template match="xhtml:html/xhtml:body/xhtml:div/xhtml:div/xhtml:div/xhtml:div/xhtml:p[@class='paragraph_default']">
    <xsl:apply-templates/>
    <xsl:text>&#xA;&#xA;</xsl:text>
  </xsl:template>
  <xsl:template match="xhtml:html/xhtml:body/xhtml:div/xhtml:div/xhtml:div/xhtml:div/xhtml:p[@class='paragraph_default']//text()">
    <xsl:value-of select="."/>
  </xsl:template>

  <xsl:template match="xhtml:html/xhtml:body/xhtml:div//xhtml:ul">
    <xsl:text>\begin{itemize}&#xA;</xsl:text>
    <xsl:text>\setlength{\itemsep}{0pt}&#xA;</xsl:text>
    <xsl:apply-templates/>
    <xsl:text>\end{itemize}&#xA;</xsl:text>
  </xsl:template>

  <xsl:template match="xhtml:html/xhtml:body/xhtml:div//xhtml:ol">
    <xsl:text>\begin{enumerate}&#xA;</xsl:text>
    <xsl:text>\setlength{\itemsep}{0pt}&#xA;</xsl:text>
    <xsl:apply-templates/>
    <xsl:text>\end{enumerate}&#xA;</xsl:text>
  </xsl:template>

  <xsl:template match="xhtml:html/xhtml:body/xhtml:div//xhtml:ul//xhtml:li | xhtml:html/xhtml:body/xhtml:div//xhtml:ol//xhtml:li">
    <xsl:text>\item </xsl:text>
    <xsl:apply-templates/>
    <xsl:text>&#xA;</xsl:text>
  </xsl:template>

  <xsl:template match="xhtml:html/xhtml:body/xhtml:div//xhtml:ul//xhtml:li//xhtml:p[@class='paragraph_default'] | xhtml:html/xhtml:body/xhtml:div//xhtml:ol//xhtml:li//xhtml:p[@class='paragraph_default']">
    <xsl:apply-templates/>
    <xsl:text>&#xA;&#xA;</xsl:text>
  </xsl:template>

  <xsl:template match="xhtml:html/xhtml:body/xhtml:div//xhtml:ul//xhtml:li//text() | xhtml:html/xhtml:body/xhtml:div//xhtml:ol//xhtml:li//text()">
    <xsl:value-of select="."/>
  </xsl:template>

  <xsl:template match="xhtml:a">
    <xsl:for-each select="text()|*/text()">
      <xsl:value-of select="."/>
    </xsl:for-each>
    <xsl:text>\footnote{\href{</xsl:text><xsl:value-of select="@href"/><xsl:text>}{\texttt{</xsl:text><xsl:value-of select="@href"/><xsl:text>}}}</xsl:text>
  </xsl:template>

  <xsl:template match="xhtml:span[@class='keyword']">
    <xsl:text>\textbf{</xsl:text>
    <xsl:apply-templates/>
    <xsl:text>}</xsl:text>
  </xsl:template>

  <xsl:template match="xhtml:span[@class='emphasis']">
    <xsl:text>\textit{</xsl:text>
    <xsl:apply-templates/>
    <xsl:text>}</xsl:text>
  </xsl:template>

  <xsl:template match="text()|@*"/>

</xsl:stylesheet>
